/**************************************************************************//**
 * @file     main.c
 * @version  V1.00
 * $Date:    19/11/12 16:42 $
 * @brief    WDT Sample Code. To test WDT Timeout Interval Period Selection,
 *           Clock Source Selection, Interrupt Mode, Reset Mode, and Wakeup
 *           Signal, etc.
 * @note
 * Copyright (C) 2019 Panchip Technology Corp. All rights reserved.
 *
 ******************************************************************************/
#include "pan271x.h"
#include "wdt_common.h"


void Clock_Init(void)
{
	PMU->SYS_CLK_CTRL |= SYS_CLK_CTRL_OTP_READ_MODE_SEL_Msk;
	PMU->SYS_CLK_CTRL &= ~(SYS_CLK_CTRL_OTP_CLK_HIGH_CYCLE_Msk | SYS_CLK_CTRL_OTP_CLK_LOW_CYCLE_Msk);
	PMU->SYS_CLK_CTRL |= ((0x1 << SYS_CLK_CTRL_OTP_CLK_HIGH_CYCLE_Pos) | (0x0 << SYS_CLK_CTRL_OTP_CLK_LOW_CYCLE_Pos));
	PMU->SYS_CLK_CTRL |= SYS_CLK_CTRL_OTP_SW_UP_CYCLE_EN_Msk;

	PMU->ANA_ANALDO |= ANA_ANALDO_EN_LDO_FSYN_AON_Msk;
    //MCU
	CLK_XthStartupConfig();
	PMU->XTH_CTRL |= XTH_CTRL_FSYNXO_BUFEN_AON_Msk;
    PMU->XTH_CTRL |= XTH_CTRL_FSYNXO_EN_AON_Msk;
	CLK_WaitClockReady(CLK_SYS_SRCSEL_XTH);

	CLK_HCLKConfig(0);

	CLK_SYSCLKConfig(CLK_DPLL_REF_CLKSEL_XTH,CLK_DPLL_OUT_48M); 
	CLK_RefClkSrcConfig(CLK_SYS_SRCSEL_DPLL_1);

	CLK_AHBPeriphClockCmd(CLK_AHBPeriph_All,ENABLE);
	CLK_APB1PeriphClockCmd(CLK_APB1Periph_All,ENABLE);
}


void Sys_Init(void)
{
    /* Unlock protected registers */
    SYS_UnlockReg();

    /* Init I/O Multi-function  */
	SYS_SET_MFP(P0,6,UART0_RX);
	SYS_SET_MFP(P0,5,UART0_TX);
	GPIO_EnableDigitalPath(P0,BIT6);

	UART_Init(UART0, 115200);

    SYS_LockReg();
}

void WDT_PrintSampleInfo()
{
    SYS_TEST("\n");
    SYS_TEST("+------------------------------------------------------------------------+ \n");
    SYS_TEST("|                      PAN271x WDT Sample Code.                          | \n");
    SYS_TEST("+------------------------------------------------------------------------+ \n");
    SYS_TEST("|    Press key to start specific testcase:                               | \n");
    SYS_TEST("|                                                                        | \n");
    SYS_TEST("|    Input '1'    Testcase 1: Interrupt Mode.                            | \n");
    SYS_TEST("|    Input '2'    Testcase 2: Reset Mode.                                | \n");
    SYS_TEST("+------------------------------------------------------------------------+ \n");
}

/*------------------
    Main function
 ------------------*/
int main(void)
{
    char c;

    Clock_Init();
    Sys_Init();

    SYS_TEST("\nCPU @ %dHz\n", SystemCoreClock);
	SYS_TEST("NOTE: Wdt clock source is RCL or XTL!!! \n");
    WDT_TestModuleInit();
    WDT_PrintSampleInfo();
    c = getchar();
    while( c )
    {
        SYS_TEST("\n");
        switch(c)
        {
            /* 1. Interrupt Mode */
            case '1':
                WDT_TestFunctionEnter(0);
                break;
            /* 2. Reset Mode */
            case '2':
                WDT_TestFunctionEnter(1);
                break;
            default:
                SYS_WARN("Cannot find testcase %c!\n", c);
                break;
        }
        WDT_PrintSampleInfo();
        c = getchar();
    }
}
